<template>
  <div class="branch">
    <el-form
      :inline="true"
      :model="dataForm"
      @keyup.enter.native="getDataList()">
      <!-- <el-form-item>
        <el-input
          v-model="dataForm.key"
          placeholder="用户名／用户操作"
          clearable
        ></el-input>
      </el-form-item>
      <el-form-item>
        <el-button @click="getDataList()">查询</el-button>
      </el-form-item> -->
      <el-form-item>
        <el-button v-if="isAuth('sys:role:save')" type="primary" @click="addOrUpdateHandle()">新增</el-button>
      </el-form-item>
      <el-form-item>
        <el-button v-if="isAuth('sys:role:delete')" type="danger" @click="deleteHandle()" :disabled="selectionDataList.length <= 0">批量删除</el-button>
      </el-form-item>
    </el-form>
    <el-table
      :data="dataList"
      @selection-change="selectionChangeHandle"
      v-loading="dataListLoading"
      style="width: 100%">
      <el-table-column
        type="selection"
        header-align="center"
        align="center"
        width="50">
      </el-table-column>
      <el-table-column
        prop="name"
        header-align="center"
        align="center"
        label="名称">
      </el-table-column>
      <el-table-column
        prop="location"
        header-align="center"
        align="center"
        label="地址">
      </el-table-column>
      <el-table-column
        prop="manager"
        header-align="center"
        align="center"
        label="负责人">
      </el-table-column>
      <el-table-column
        prop="buildTime"
        header-align="center"
        align="center"
        :show-overflow-tooltip="true"
        label="建立日期">
      </el-table-column>
      <el-table-column
        fixed="right"
        header-align="center"
        align="center"
        label="操作">
        <template slot-scope="scope">
          <el-button v-if="isAuth('sys:user:update')" type="text" size="small" @click="addOrUpdateHandle(scope.row)">修改</el-button>
          <el-button v-if="isAuth('sys:user:delete')" type="text" size="small" @click="deleteHandle(scope.row.id)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-dialog
      :title="!form.id ? '新增' : '修改'"
      :close-on-click-modal="false"
      :visible.sync="visible"
      @close="cancel">
      <el-form :model="form" ref="form" @keyup.enter.native="formSubmit()" label-width="80px">
        <el-form-item label="牧场名称" prop="name">
          <el-input v-model="form.name" placeholder="牧场名称"></el-input>
        </el-form-item>
        <el-form-item label="管理员" prop="manager">
          <el-input v-model="form.manager" placeholder="牧场管理员"></el-input>
        </el-form-item>
        <el-form-item label="地址" prop="location">
          <el-input v-model="form.location" placeholder="地址"></el-input>
        </el-form-item>
        <el-form-item label="日期" prop="buildTime">
          <el-date-picker
            v-model="form.buildTime"
            type="date" 
            value-format="yyyy-MM-dd" 
            placeholder="选择日期">
          </el-date-picker>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="cancel">取消</el-button>
        <el-button type="primary" @click="formSubmit()">确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
export default {
  data () {
    return {
      dataForm: {
        key: ''
      },
      dataList: [
        {
          buildTime: '',
          id: '',
          location: '',
          manager: '',
          name: '',
        }
      ],
      pageIndex: 1,
      pageSize: 10,
      totalPage: 0,
      dataListLoading: false,
      selectionDataList: [],
      visible: false,
      form: {
        id: '',
        location: '',
        manager: '',
        name: '',
        buildTime: ''
      }
    }
  },
  created () {
    this.getDataList()
  },
  methods: {
    // 获取数据列表
    getDataList () {
      this.dataListLoading = true
      this.$http({
        url: this.$http.adornUrl('/management/pasture/list'),
        method: 'post'
      }).then(({ data }) => {
        if (data && data.code === 0) {
          this.dataList = data.page.list
          this.totalPage = data.page.totalCount
        } else {
          this.dataList = []
          this.totalPage = 0
        }
        this.dataListLoading = false
      })
    },
    // 每页数
    sizeChangeHandle (val) {
      this.pageSize = val
      this.pageIndex = 1
      this.getDataList()
    },
    // 当前页
    currentChangeHandle (val) {
      this.pageIndex = val
      this.getDataList()
    },
    // 新增 or 修改牧场
    addOrUpdateHandle (row) {
      // 显示牧场新增 or 修改面板
      this.visible = true
      if (row) {
        this.form = row
      }
    },
    // 选择n个牧场
    selectionChangeHandle (val) {
      this.selectionDataList = []
      val.forEach(item => {
        this.selectionDataList.push(item.id)
      });
    },
    // 删除n个牧场
    deleteHandle (id) {
      this.$confirm(`确定删除牧场？`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        // 删除操作
        if (id) {
          this.selectionDataList.push(id)
        }
        if (this.selectionDataList.length <= 0) {
          return
        }
        this.$http({
          url: this.$http.adornUrl('/management/pasture/delete'),
          method: 'post',
          data: this.$http.adornData(this.selectionDataList, false)
        }).then(result => {
          if (result.data.code === 0) {
            this.$message({
              message: '成功删除牧场',
              type: 'success',
              duration: 1000
            })
          } else {
            this.$message.error('删除牧场失败');
          }
          this.resetForm()
          this.selectionDataList = []
        })
      }).catch(() => {})
    },
    formSubmit () {
      if (this.form.id) {
        // 修改
        if (this.form.name && this.form.manager && this.form.location && this.form.buildTime) {
          // 进行修改操作
          this.$http({
            url: this.$http.adornUrl('/management/pasture/update'),
            method: 'post',
            data: this.$http.adornData({
              id: this.form.id,
              location: this.form.location,
              manager: this.form.manager,
              name: this.form.name,
              buildTime: this.form.buildTime
            })
          }).then(result => {
            if (result.data.code === 0) {
              this.resetForm();
              this.visible = false;
              this.$message({
                message: '成功修改牧场信息',
                type: 'success',
                duration: 1000
              })
            } else {
              this.$message.error('修改牧场信息失败');
            }
          })
        } else {
          // 请输入完整
          this.$confirm(`请输入完整`, '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }).then(() => {
            return
          }).catch(() => {})
        }
      } else {
        // 新增
        if (this.form.name && this.form.manager && this.form.location && this.form.buildTime) {
          // 进行新增操作
          this.$http({
            url: this.$http.adornUrl('/management/pasture/save'),
            method: 'post',
            data: this.$http.adornData({
              location: this.form.location,
              manager: this.form.manager,
              name: this.form.name,
              buildTime: this.form.buildTime
            })
          }).then(result => {
            if (result.data.code === 0) {
              this.resetForm();
              this.visible = false;
              this.$message({
                message: '成功添加牧场',
                type: 'success',
                duration: 1000
              })
            } else {
              this.$message.error('添加牧场失败');
            }
          })
        } else {
          // 请输入完整
          this.$confirm(`请输入完整`, '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }).then(() => {
            return
          }).catch(() => {})
        }
      }
    },
    // 清空form
    resetForm () {
      for (let i in this.form) {
        this.form[i] = ''
      }
      this.getDataList()
    },
    // 取消
    cancel () {
      this.visible = false
      this.resetForm()
    }
  }
}
</script>
<style scoped>
</style>